!function(global, factory) {
    "object" == typeof exports && "undefined" != typeof module ? module.exports = factory(require("preact"), require("dlv")) : "function" == typeof define && define.amd ? define([ "preact", "dlv" ], factory) : global.model = factory(global.preact, global.dlv);
}(this, function(preact, delve) {
    function join(arr) {
        return arr ? arr.join("\n") : "";
    }
    function get(obj, key) {
        return key ? obj[key] : obj;
    }
    function shallowEqual(a, b) {
        for (var key in a) if (a[key] !== b[key]) return !1;
        for (var _key in b) if (!(_key in a)) return !1;
        return !0;
    }
    function removeKeyFromObject(key, obj) {
        return obj.hasOwnProperty(key) && (obj = _extends$1({}, obj), delete obj[key]), 
        obj;
    }
    function noop() {}
    function _possibleConstructorReturn(self, call) {
        if (self) return !call || "object" != typeof call && "function" != typeof call ? self : call;
    }
    function _inherits(subClass, superClass) {
        "function" != typeof superClass && null !== superClass || (subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: !1,
                writable: !0,
                configurable: !0
            }
        }), superClass && (Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass));
    }
    function model(namespace) {
        var mapToProps = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {}, mapLibToProps = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : noop, CACHE = {};
        return function(Child) {
            return function(_Component) {
                function ModelDataWrapper(props, context) {
                    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));
                    return _this.state = {}, _this.currentKeys = {}, _this.tracking = {}, _this.counter = 0, 
                    _this.mapping = mapLibToProps(get(context), props), _this.refresh = function() {
                        _this.invoke(_this.props, !1, !0);
                    }, _this;
                }
                return _inherits(ModelDataWrapper, _Component), ModelDataWrapper.prototype.shouldComponentUpdate = function(props, state) {
                    return !shallowEqual(props, this.props) || !shallowEqual(state, this.state);
                }, ModelDataWrapper.prototype.invoke = function(props, keysOnly, refresh) {
                    var _this2 = this, source = get(this.context, namespace), isFunction = "function" == typeof mapToProps, mapping = isFunction ? mapToProps(props) : mapToProps, keys = [];
                    for (var prop in mapping) {
                        (function(prop) {
                            if (mapping.hasOwnProperty(prop)) {
                                var path = mapping[prop], args = [];
                                Array.isArray(path) && (args = path.slice(1), path = path[0]), isFunction || (args = args.map(function(p) {
                                    return "string" == typeof p && p in props ? props[p] : p;
                                }));
                                var key = JSON.stringify([ namespace, path ].concat(args));
                                if (keys.push(key), keysOnly) return "continue";
                                if (!refresh && _this2.currentKeys[prop] === key) return "continue";
                                _this2.currentKeys[prop] = key;
                                var p = void 0;
                                if ("function" == typeof path) p = path(); else {
                                    if ("string" == typeof path) {
                                        var fn = delve(source, path);
                                        if (!fn) return;
                                        throw Error(namespace + "." + path + " not found.");
                                    }
                                    p = path;
                                }
                                if (p && void 0 !== p.then && p.__modelConnectResolved && (p = p.__modelConnectResolved), 
                                p && void 0 !== p.then) {
                                    var newState = {}, _state = _this2.state, pending = _state.pending, rejected = _state.rejected;
                                    if (pending) {
                                        if (!pending[prop]) {
                                            var _extends2;
                                            newState.pending = _extends({}, pending, (_extends2 = {}, _extends2[prop] = !0, 
                                            _extends2));
                                        }
                                    } else {
                                        var _newState$pending;
                                        newState.pending = (_newState$pending = {}, _newState$pending[prop] = !0, _newState$pending);
                                    }
                                    rejected && rejected[prop] && (newState.rejected = removeKeyFromObject(prop, rejected));
                                    var id = ++_this2.counter;
                                    _this2.tracking[prop] = id, p.then(function(data) {
                                        p.__modelConnectResolved = data;
                                        var newState = {};
                                        return newState[prop] = CACHE[key] = data, newState;
                                    }).catch(function(err) {
                                        if (_this2.tracking[prop] === id) {
                                            var rejected = _this2.state.rejected && _extends({}, _this2.state.rejected) || {};
                                            rejected[prop] = err;
                                            var newState = {
                                                rejected: rejected
                                            };
                                            return CACHE[key] && (newState[prop] = CACHE[key]), newState;
                                        }
                                    }).then(function(newState) {
                                        if (_this2.tracking[prop] === id) {
                                            delete _this2.tracking[prop];
                                            var pending = _this2.state.pending;
                                            pending && pending[prop] && (newState.pending = removeKeyFromObject(prop, pending)), 
                                            _this2.setState(newState);
                                        }
                                    }), void 0 !== CACHE[key] && (newState[prop] = CACHE[key]), _this2.setState(newState);
                                } else {
                                    var _this2$setState;
                                    _this2.setState((_this2$setState = {}, _this2$setState[prop] = p, _this2$setState));
                                }
                            }
                        })(prop);
                    }
                    return this.keys = keys;
                }, ModelDataWrapper.prototype.componentWillMount = function() {
                    this.invoke(this.props);
                }, ModelDataWrapper.prototype.componentWillReceiveProps = function(nextProps) {
                    shallowEqual(nextProps, this.props) || join(this.keys) === join(this.invoke(nextProps, !0)) || this.invoke(nextProps);
                }, ModelDataWrapper.prototype.render = function(props, state) {
                    return preact.h(Child, _extends({
                        refresh: this.refresh
                    }, this.mapping, props, state));
                }, ModelDataWrapper;
            }(preact.Component);
        };
    }
    delve = "default" in delve ? delve.default : delve;
    var _extends$1 = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
        }
        return target;
    }, _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
        }
        return target;
    };
    return model;
});
//# sourceMappingURL=model-connect.js.map